var isLowGPU = !!navigator.userAgent.match(/(armv)/);
var cordova;
var recentExitBack;
var detectCatTMO;
var donationProductIds = ["de.markusliebschner.thatlist.donation1", "de.markusliebschner.thatlist.donation2", "de.markusliebschner.thatlist.donation3"];
var categoriesProductId = "com.markenapps.thatlist.categories";
var noadsProductId = "com.markenapps.thatlist.noads";
var noads2ProductId = "com.markenapps.thatlist.noads2";
var allProductIds = [categoriesProductId, noadsProductId, noads2ProductId].concat(donationProductIds);
var backupBasePath = "https://app-dot-backupmarkenapps.appspot.com/!QBc3AGq1W5O6IX6zBqE0Wl1/api/backup/";
var baseHost = "https://thatshoppinglist-dot-servemarkenapps.appspot.com";
//var basePath = baseHost + "/!gzy7moRDqs7T4Nv0E_IF";
var basePath = baseHost + "/!q4ChRZiH_noxF02UYGJ-Mt76RcjoU2";
var keyboardHeight = 0;
var throttleToggleBannerTMO, stopBackgroundTMO;
function getBackupId() {
    //return window.btoa(window.device.uuid + ".zip").replace(/\+/g, "-").replace(/\//g, "_").replace(/=/g, "");
    if (!window.device || !window.device.id) {
        var bckId = localStorage.getItem("backup_id") || thatlist.util.id("xxxxxxxxxxxxxxxxxxxxxxxxx", "ABCDEFGHJKLMNPQRSTUVWXYZ");
        localStorage.setItem("backup_id", bckId);
        return bckId;
    }
    return security.md5(window.device.uuid + ".zip", window.device.uuid.substring(2, 4) + window.device.uuid.substring(5, 7));
}
function getBackupPath(backupId) {
    if (!backupId)
        backupId = getBackupId();
    return backupBasePath + backupId;
}
var thatlist = com.markenapps.thatlist;
var app, vm;
var lang = "de";
var $$ = Dom7;
var translation;
var iconNames = ["icon-cherries", "icon-banana", "icon-apple", "icon-carrot", "icon-nut", "icon-oil", "icon-spices", "icon-ketchup", "icon-dressing", "icon-can", "icon-instantmeal", "icon-soup", "icon-sauce", "icon-jam", "icon-honey", "icon-coffee", "icon-tea", "icon-muffin", "icon-bread", "icon-pasta", "icon-rice", "icon-cereals", "icon-chef", "icon-sushi", "icon-fish", "icon-meat", "icon-snowflake", "icon-icecream", "icon-cheese", "icon-milk", "icon-bottle", "icon-beer", "icon-spirits", "icon-cocktail", "icon-pretzel", "icon-candies", "icon-house", "icon-baby", "icon-soother", "icon-toiletpaper", "icon-haircomp", "icon-libstick", "icon-soap", "icon-broom", "icon-broombucket", "icon-washingliquid", "icon-cleaner", "icon-petfood", "icon-pets", "icon-pot", "icon-glasses", "icon-pen", "icon-officetape", "icon-clothes", "icon-shoes", "icon-mixer", "icon-washingmacine", "icon-barbeque", "icon-car", "icon-bike", "icon-powertools", "icon-plug", "icon-tools", "icon-brush", "icon-shower", "icon-pipe", "icon-screw", "icon-light", "icon-roof", "icon-wood", "icon-hardhat", "icon-brick", "icon-mower", "icon-garden", "icon-flower", "icon-ball", "icon-cubes", "icon-dumbbell", "icon-media", "icon-tv", "icon-pills", "icon-drugs", "icon-register", "icon-priolow", "icon-priomed", "icon-priohigh", "icon-more", "icon-blank"];
var writeThrottle;
var fracRegExp = /^\d+(\s*\d*(\/+\d+))*/;
var phs = "{{";
var phe = "}}";
var $translate = {
    instant: function (text, data) {
        var trans = translation[text];
        if (data) {
            for (var key in data) {
                trans = trans.replace(phs + key + phe, data[key]);
            }
        }
        return trans;
    }
};
// Init F7 Vue Plugin
Framework7.use(Framework7Vue);
// Init Page Components
Vue.component('page-list', {
    data: function () {
        return vm;
    },
    template: '#page-list'
});
Vue.component('page-list-history', {
    data: function () {
        return vm;
    },
    template: '#page-list-history'
});
Vue.component('page-item-edit', {
    data: function () {
        return vm;
    },
    template: '#page-item-edit'
});
Vue.component('page-list-edit', {
    data: function () {
        return vm;
    },
    template: '#page-list-edit'
});
Vue.component('page-category-edit', {
    data: function () {
        return vm;
    },
    template: '#page-category-edit'
});
Vue.component('page-app-backup', {
    data: function () {
        return vm;
    },
    template: '#page-app-backup'
});
Vue.component('page-app-connect', {
    data: function () {
        return vm;
    },
    template: '#page-app-connect'
});
Vue.component('page-app-join', {
    data: function () {
        return vm;
    },
    template: '#page-app-join'
});
Vue.component('page-app-prefs', {
    data: function () {
        return vm;
    },
    template: '#page-app-prefs'
});
Vue.component('page-app-feedback', {
    data: function () {
        return vm;
    },
    template: '#page-app-feedback'
});
Vue.component('page-not-found', {
    data: function () {
        return vm;
    },
    template: '#page-not-found'
});
Vue.directive('longpress', {
    bind: function (el, binding, vNode) {
        // Make sure expression provided is a function
        if (typeof binding.value !== 'function') {
            // Fetch name of component
            var compName = vNode.context.name;
            // pass warning to console
            var warn = "[longpress:] provided expression '" + binding.expression + "' is not a function, but has to be";
            if (compName) {
                warn += "Found in component '" + compName + "' ";
            }
            console.warn(warn);
        }
        // Define variable
        var pressTimer = null;
        // Define funtion handlers
        // Create timeout ( run function after 600ms )
        var start = function (e) {
            if (e.type === 'click' && e.button !== 0) {
                return;
            }
            if (pressTimer === null) {
                pressTimer = setTimeout(function () {
                    // Run function
                    handler(e);
                }, 600);
            }
        };
        // Cancel Timeout
        var cancel = function (e) {
            // Check if timer has a value or not
            if (pressTimer !== null) {
                clearTimeout(pressTimer);
                pressTimer = null;
            }
        };
        // Run Function
        var handler = function (e) {
            var idx = thatlist.util.indexOfItem(vNode.data.key, vm.list.items);
            if (idx >= 0)
                binding.value(vm.list.items[idx]);
        };
        // Add Event listeners
        el.addEventListener("mousedown", start);
        el.addEventListener("touchstart", start);
        // Cancel timeouts if this events happen
        el.addEventListener("click", cancel);
        el.addEventListener("mouseout", cancel);
        el.addEventListener("touchend", cancel);
        el.addEventListener("touchcancel", cancel);
    }
});
var inputMirrorElem;
function updateInputWidth(event) {
    // var options = { maxWidth: Math.round(window.innerWidth / 2)-20, minWidth: 20, comfortZone: 0 };
    var options = { comfortZone: 0 };
    if (!inputMirrorElem) {
        inputMirrorElem = document.createElement("span");
        Object.assign(inputMirrorElem.style, {
            position: "absolute",
            top: "-9999px",
            left: "-9999px",
            width: "auto",
            whiteSpace: "nowrap",
            opacity: 0
        });
        document.body.appendChild(inputMirrorElem);
    }
    var el = (event || window.event).target;
    if (!el || !el.nodeType || el.nodeType !== 1)
        return;
    var val = el.value || el.placeholder;
    setTimeout(function () {
        var styles = window.getComputedStyle(el, null);
        Object.assign(inputMirrorElem.style, {
            border: styles.getPropertyValue("border"),
            fontSize: styles.getPropertyValue("font-size"),
            fontFamily: styles.getPropertyValue("font-family"),
            fontWeight: styles.getPropertyValue("font-weight"),
            letterSpacing: styles.getPropertyValue("letter-spacing"),
            padding: styles.getPropertyValue("padding"),
            textTransform: styles.getPropertyValue("text-transform"),
            ariaHidden: true
        });
        inputMirrorElem.innerHTML = val.replace(/&/g, "&amp;").replace(/\s/g, "&nbsp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
        var newWidth = inputMirrorElem.getBoundingClientRect().width + options.comfortZone;
        // if (newWidth > options.maxWidth) { newWidth = options.maxWidth; }
        // if (newWidth < options.minWidth) { newWidth = options.minWidth; }
        if (newWidth != el.getBoundingClientRect().width) {
            el.style.width = newWidth + "px";
        }
    }, 0);
}
Vue.directive("input-autosize", {
    params: ["value"],
    bind: function (el, binding, vnode, oldVnode) {
        Vue.nextTick(function () {
            updateInputWidth({ "target": el });
        });
        el.addEventListener("input", updateInputWidth);
    },
    unbind: function (el, binding, vnode, oldVnode) {
        el.removeEventListener("input", updateInputWidth);
    }
});
function initVue(assets) {
    // Init App
    vm = new Vue({
        el: '#app',
        beforeMount: function () {
            var langs = thatlist.App.getSupportedLanguages();
            var defLang = thatlist.util.getFirstBrowserLanguage();
            if (langs[defLang])
                this.langs[defLang] = langs[defLang]; // + ' (' + translation.device + ')';
            else
                this.langs[''] = translation.device + ' (' + defLang + ')';
            for (var lang_1 in langs) {
                if (!this.langs[lang_1]) {
                    var langname = langs[lang_1];
                    this.langs[lang_1] = langname;
                }
            }
        },
        data: function () {
            return {
                mobileServiceProvider: false,
                translation: translation,
                colors: assets[3],
                iconNames: iconNames,
                app: app,
                theme: "",
                list: null,
                rerender: false,
                searchbarFocused: false,
                addFabOpen: false,
                filterText: "",
                parsedItemCat: { "cat": "", "name": "" },
                favouritesByCategory: [],
                favouritesByPrio: [],
                recentAddItem: null,
                selectedItems: [],
                selectedItemsTarget: "",
                previewItemsToAdd: [],
                focusedItem: null,
                editItem: null,
                focusedCategory: null,
                editCategory: null,
                selectListAction: null,
                fixDuplicateAction: null,
                editList: null,
                speechActive: false,
                newListTitle: "",
                toast: "",
                locked: false,
                shoppingModeOn: false,
                showHiddenCats: false,
                wordsToNumber: [],
                historyPrioLimit: 0,
                historyCatLimit: 0,
                curHistoryTab: "prio",
                feedback: "",
                langs: {},
                curKeyboardHeight: 0,
                debug: "",
                screenshot: false,
                keyboard: false,
                fontSizes: [$translate.instant('tiny'), $translate.instant('small'), $translate.instant('medium'), $translate.instant('large'), $translate.instant('very_large')],
                // Framework7 parameters here
                f7params: {
                    root: '#app',
                    language: app.getLanguage(),
                    id: 'de.markusliebschner.thatlist',
                    name: translation.app_title,
                    theme: 'auto',
                    initOnDeviceReady: false,
                    // App routes
                    view: {
                        pushStateOnLoad: false,
                        pushState: true,
                        stackPages: true,
                        animate: true,
                        iosDynamicNavbar: false,
                        iosSwipeBackActiveArea: 50,
                        allowDuplicateUrls: false
                    },
                    dialog: {
                        buttonOk: translation.ok,
                        buttonCancel: translation.cancel,
                        closeByBackdropClick: true,
                        autoFocus: true
                    },
                    panel: {
                        swipe: 'left',
                    },
                    touch: {
                        disableContextMenu: false,
                        fastClicks: true
                    },
                    statusbar: {
                        enabled: Framework7.device.ios && Framework7.device.webView,
                        overlay: Framework7.device.ios || 'auto',
                    },
                    // App routes 
                    routes: [
                        {
                            path: '/lists/:ts',
                            component: 'page-list',
                            beforeEnter: function (routeTo, routeFrom, resolve, reject) {
                                if (vm) {
                                    // log("history", vm.$f7.views.current.router.history)
                                    // if (vm.$f7.views.current.router.history.length) {
                                    //   let routeIdx = vm.$f7.views.current.router.history.indexOf(routeTo.url);
                                    //   if ( routeIdx >= 0 && routeIdx < vm.$f7.views.current.router.history.length-1) {
                                    //     reject();
                                    //     vm.$f7.views.current.router.back(routeTo.url, { "force": true });
                                    //     return;
                                    //   }
                                    // }
                                    vm.focusedCategory = vm.focusedItem = null;
                                    vm.selectList(routeTo.params.ts, true);
                                    vm.$f7.panel.enableSwipe("left");
                                }
                                resolve();
                                Vue.nextTick(function () {
                                    window.viewReady = true;
                                });
                            },
                            beforeLeave: function (routeTo, routeFrom, resolve, reject) {
                                if (vm) {
                                    vm.focusedItem = null;
                                }
                                resolve();
                            }
                        }, {
                            path: '/lists/:ts/edit',
                            component: 'page-list-edit'
                        },
                        {
                            path: '/lists/:ts/history',
                            component: 'page-list-history',
                            beforeEnter: function (routeTo, routeFrom, resolve, reject) {
                                if (vm) {
                                    vm.historyPrioLimit = 50;
                                    vm.historyCatLimit = 50;
                                    vm.handleHistoryTapShow("prio");
                                }
                                resolve();
                            },
                            beforeLeave: function (routeTo, routeFrom, resolve, reject) {
                                resolve();
                            }
                        },
                        {
                            path: '/lists/:ts/item/edit',
                            component: 'page-item-edit'
                        },
                        {
                            path: '/lists/:ts/category/edit',
                            component: 'page-category-edit'
                        },
                        {
                            path: '/lists/:ts/connect',
                            component: 'page-app-connect'
                        },
                        {
                            path: '/app/backup',
                            component: 'page-app-backup'
                        },
                        {
                            path: '/app/join',
                            component: 'page-app-join'
                        },
                        {
                            path: '/app/prefs',
                            component: 'page-app-prefs'
                        },
                        {
                            path: '/app/feedback',
                            component: 'page-app-feedback'
                        },
                        {
                            path: '(.*)',
                            url: 'loading.html',
                            beforeEnter: function (routeTo, routeFrom, resolve, reject) {
                                log("NO ROUTE");
                                resolve();
                                promiseAppReady.then(function () {
                                    vm.$f7.views.current.router.clearHistory();
                                    vm.$f7.views.main.router.navigate("/lists/" + vm.app.selectedListTS, { "pushState": true, "animate": false, "reloadAll": true });
                                    vm.$f7.panel.enableSwipe("left");
                                });
                            }
                        }
                    ],
                }
            };
        },
        methods: {
            noop: function () {
            },
            translate: function (text, data) {
                return $translate.instant(text, data);
            },
            showAds: function () {
                var app = this.app;
                app.purchases = [];
                setTimeout(function () {
                    thatlist.util.showAd(true);
                }, 3000);
            },
            hideAds: function () {
                setTimeout(function () {
                    thatlist.util.showAd(false);
                }, 3000);
            },
            setCat: function (o, cat, msg) {
                if (!o) {
                    logError("no o for cat: " + cat + " " + msg);
                }
                else {
                    o.cat = cat;
                }
            },
            updateItem: function (item, props) {
                var list = this.list;
                var curItemIdx = thatlist.util.indexOfItem(item.name, list.items);
                if (curItemIdx >= 0) {
                    this.filterText = "";
                    list.items[curItemIdx].count = "";
                    Vue.nextTick(function () {
                        if ("count" in props)
                            list.items[curItemIdx].count = props.count;
                        if ("cat" in props)
                            list.items[curItemIdx].cat = props.cat;
                        app.save();
                    });
                }
                else {
                    this.addItem(item, { 'animate': true, 'sort': true, 'keepPrio': true });
                }
            },
            back: handleBack,
            alert: function (text) {
                alert(text);
            },
            clearGUI: function () {
                log("clearGUI");
                vm.toast = vm.focusedItem = vm.focusedCategory = vm.showHiddenCats = null;
                vm.$f7.panel.close();
                // vm.$f7.dialog.close(); already connected dialog will be closed otherwise
                vm.$f7.popover.close();
                vm.$f7.actions.close();
            },
            selectList: function (ts, noNavigate, sync) {
                var _this = this;
                //TODO verbessern, die function sollte nur den listen wechsel handeln und nich durchführen (also nicht .navigate("/lists/" + list.ts machen)
                console.log("select list ");
                var list = this.list;
                if (!list || list.ts != ts) {
                    this.cancelInput();
                    if (this.selectedItems.length)
                        this.selectedItems = [];
                    if (list) {
                        list.commit();
                    }
                    this.list = list = app.selectList(ts);
                    app.save();
                    this.checkBgMode();
                    this.shoppingModeOn = false;
                    thatlist.util.allowSleep();
                    console.log("sync");
                    setTimeout(function () { _this.syncList(); }, 1000);
                }
                else if (sync) {
                    setTimeout(function () { _this.syncList(); }, 500);
                }
                if (!noNavigate) {
                    vm.$f7.views.main.router.navigate("/lists/" + list.ts, { "animate": false, "reloadAll": true });
                    // console.log("enableSwipe");
                    vm.$f7.panel.enableSwipe("left");
                }
            },
            focusInput: function (id, selectText) {
                // thatlist.util.focusInput(id || ".page-current .searchbar input", selectText);
                thatlist.util.focusInput(id || "#searchIpt", selectText);
            },
            handleAddFabClicked: function () {
                if (!this.searchbarFocused && !this.addFabOpen) {
                    this.debounce('shoppingModeOn', false, 0);
                    this.debounce('addFabOpen', true, 0);
                    this.focusInput();
                }
                else {
                    this.cancelInput();
                }
            },
            cancelInput: function () {
                if (this.filterText)
                    this.filterText = "";
                this.selectListAction = null;
                this.fixDuplicateAction = null;
                // thatlist.util.focusInput("#main-fab-btn");
                this.debounce('addFabOpen', false, 0);
                thatlist.util.hideKeyboard();
                window.cancelRecordSpeech = true;
                this.stopRecordSpeech();
            },
            cancelFixDuplicate: function () {
                var _this = this;
                if (this.filterText)
                    this.filterText = "";
                if (this.fixDuplicateAction.next) {
                    var cmd_1 = this.fixDuplicateAction.next.cmd;
                    var params_1 = this.fixDuplicateAction.next.params;
                    this.fixDuplicateAction = null;
                    //to enabale auto resize amount inputs
                    Vue.nextTick(function () {
                        _this[cmd_1](params_1[0], params_1[1]);
                    });
                }
                else {
                    this.fixDuplicateAction = null;
                    this.focusInput();
                }
            },
            fixDuplicate: function (item, count) {
                //if cat was changed in preview
                this.updateItem(item, { "count": count, "cat": item.cat });
                this.cancelFixDuplicate();
            },
            setEditItem: function (item) {
                this.editItem = JSON.parse(JSON.stringify(item));
                this.editItemOrig = item;
                vm.$f7.views.main.router.navigate("/lists/" + this.list.ts + "/item/edit");
            },
            saveEditItem: function () {
                var list = this.list;
                var checkProps = {
                    "name": "enter_name",
                    "cat": "select_cat"
                };
                for (var propName in checkProps) {
                    if (!this.editItem[propName]) {
                        vm.$f7.toast.create({
                            text: $translate.instant(checkProps[propName]),
                            closeTimeout: 4000,
                            destroyOnClose: true
                        }).open();
                        return;
                    }
                }
                var wasInItems = !!list.removeItem(this.editItemOrig);
                var wasInPicked = thatlist.util.indexOfItem(this.editItemOrig.name, list.pickedItems) >= 0;
                if (this.editItemOrig.name !== this.editItem.name)
                    list.removeFavourite(this.editItemOrig);
                //gen add and del commands for picked items
                if (wasInPicked)
                    list.addPickedItem(this.editItem, { "replaceItem": this.editItemOrig });
                this.editItemOrig.name = this.editItem.name;
                if (!this.editItemOrig.count && this.editItem.count)
                    Vue.set(this.editItemOrig, "count", this.editItem.count);
                else
                    this.editItemOrig.count = this.editItem.count;
                log(".cat= 1");
                this.editItemOrig.cat = this.editItem.cat;
                //add/replace item TODO do not increase prio
                if (wasInItems)
                    list.addItem(this.editItemOrig, { "keepPrio": true });
                else
                    list.addFavourite(this.editItemOrig, { "keepPrio": true });
                app.save();
                handleBack();
            },
            removeItem: function (item) {
                var list = this.list;
                list.deleteItem(item);
                app.save();
                handleBack();
            },
            setEditCategory: function (category) {
                var list = this.list;
                //make observable
                if (!category.icon)
                    category.icon = "";
                this.editCategory = JSON.parse(JSON.stringify(category));
                this.editCategoryOrig = category;
                vm.$f7.views.main.router.navigate("/lists/" + list.ts + "/category/edit");
            },
            saveEditCategory: function () {
                var list = this.list;
                var checkProps = {
                    "title": "enter_name",
                    "icon": "select_icon",
                    "color": "select_color"
                };
                for (var propName in checkProps) {
                    if (!this.editCategory[propName]) {
                        vm.$f7.toast.create({
                            text: $translate.instant(checkProps[propName]),
                            closeTimeout: 4000,
                            destroyOnClose: true
                        }).open();
                        return;
                    }
                }
                this.editCategoryOrig.title = this.editCategory.title;
                this.editCategoryOrig.colorName = this.editCategory.colorName;
                this.editCategoryOrig.color = this.editCategory.color;
                this.editCategoryOrig.icon = this.editCategory.icon;
                if (!this.editCategoryOrig.name) {
                    //new category
                    this.editCategoryOrig.name = (this.editCategoryOrig.title.substring(0, 20)) + "_" + (this.editCategoryOrig.icon.split("-")[1]) + "_" + this.editCategoryOrig.color.substring(1);
                    app.categories[this.editCategoryOrig.name] = this.editCategoryOrig;
                    list.catOrder.push(this.editCategoryOrig.name);
                    if (this.editItem)
                        this.editItem.cat = this.editCategoryOrig.name;
                }
                app.save();
                handleBack();
            },
            onSortCats: function (e) {
                // Sort data
                var movedCat = this.list.catOrder.splice(e.detail.from, 1)[0];
                this.list.catOrder.splice(e.detail.to, 0, movedCat);
                this.list.sort();
                app.save();
            },
            addCategory: function () {
                var randColor = this.colors[Math.floor(Math.random() * this.colors.length)];
                var randColorVariation = randColor.variations[Math.floor(Math.random() * 5 + 3)];
                this.setEditCategory({
                    "title": "",
                    "colorName": randColor.color,
                    "color": randColorVariation.hex
                });
            },
            hideCategory: function (category) {
                var list = this.list;
                list.hideCategory(category);
                app.save();
                handleBack();
            },
            unhideCategory: function (category) {
                var list = this.list;
                list.unhideCategory(category);
                app.save();
            },
            setUnit: function (unit) {
                var newSearchText = this.filterText.replace(/[^0-9,.]/g, '');
                if (unit.name) {
                    newSearchText += unit.name;
                }
                else {
                    newSearchText += this.parsedItem.isSing ? unit.title_sing : unit.title;
                }
                newSearchText += " ";
                this.filterText = newSearchText;
                this.focusInput();
            },
            addItem: function (item, options) {
                var _this = this;
                if (!item)
                    return;
                //restore count if re added from picked items (correction)
                if (!item.count && item.tmp && item.tmp.pickedCount) {
                    item.count = item.tmp.pickedCount;
                    delete item.tmp.pickedCount;
                }
                var list = this.list;
                if (!options)
                    options = {};
                if (options.check) {
                    var curItemIdx = thatlist.util.indexOfItem(item.name, list.items);
                    if (curItemIdx >= 0) {
                        var current_1 = list.items[curItemIdx];
                        var alternatives_1 = [];
                        var newCount = item.count || item.tmp && item.tmp.count;
                        var altCounts = thatlist.util.getEstimatedCountSums(current_1.count, newCount);
                        //must be != because string to number compare
                        if (newCount && altCounts.indexOf(newCount) < 0)
                            altCounts.push(newCount);
                        altCounts.push("");
                        altCounts.forEach(function (altCount) {
                            var alt = JSON.parse(thatlist.util.toJSON(current_1));
                            if (item.cat)
                                alt.cat = item.cat;
                            alt.count = altCount;
                            alternatives_1.push(alt);
                        });
                        thatlist.util.hideKeyboard();
                        this.fixDuplicateAction = {
                            "current": current_1,
                            "alternatives": alternatives_1
                        };
                        return;
                    }
                }
                if (this.filterText)
                    this.filterText = "";
                if (options.focus) {
                    this.debounce('addFabOpen', true, 0);
                    this.focusInput();
                }
                var pickedItem = list.removePickedItem(item);
                var itemClone = JSON.parse(JSON.stringify(item));
                if (options.animate && pickedItem) {
                    setTimeout(function () {
                        //clone otherwise we can not distinguish instances e.g focusedItem === item will match in picked and items
                        list.addItem(itemClone, options);
                        if (!options.noMark)
                            _this.recentAddItem = itemClone;
                        app.save();
                        _this.rateApp();
                    }, 220);
                }
                else {
                    //do not user setTimeout 0, otherwise fix duplicate will not work with add items (e.g. from speech)
                    //clone otherwise we can not distinguish instances e.g focusedItem === item will match in picked and items
                    list.addItem(itemClone, options);
                    if (!options.noMark)
                        this.recentAddItem = itemClone;
                    app.save();
                    this.rateApp();
                }
            },
            toggleSelectedItem: function (item, target) {
                var idx = thatlist.util.indexOfItem(item.name, this.selectedItems);
                if (this.selectedItemsTarget !== target) {
                    this.selectedItemsTarget = target;
                    this.selectedItems = [];
                }
                if (idx >= 0) {
                    this.selectedItems.splice(idx, 1);
                }
                else {
                    this.selectedItems.push(item);
                }
                // if (!item.tmp || item.tmp.selected === void (0)) Vue.set(item, "tmp", { "selected": true });
                // else item.tmp.selected = !item.tmp.selected;
            },
            addItems: function (items, options) {
                for (var i = 0; i < items.length; i++) {
                    var item = items[i];
                    this.addItem(item, options);
                    //break add if duplicate found
                    if (this.fixDuplicateAction) {
                        var nextItems = items.splice(i + 1);
                        if (nextItems.length) {
                            this.fixDuplicateAction.next = {
                                "cmd": "addItems",
                                "params": [nextItems, options]
                            };
                        }
                        this.list.sort();
                        return;
                    }
                }
                this.list.sort();
            },
            moveItems: function (toList) {
                var _this = this;
                if (!toList) {
                    this.selectListAction = this.moveItems;
                }
                else {
                    var list = this.list;
                    var items;
                    if (this.selectedItems.length) {
                        items = this.selectedItems;
                    }
                    else {
                        items = this.list.items;
                    }
                    var itemsToMove_1 = [];
                    for (var i = items.length; i--;) {
                        var item = items[i];
                        itemsToMove_1.push(item);
                        list.removeItem(item);
                    }
                    //switch to target list
                    this.selectList(toList, true, true);
                    setTimeout(function () {
                        _this.addItems(itemsToMove_1, { "animate": true, "check": true });
                        app.save();
                    }, 200);
                }
            },
            removeSelectedItems: function () {
                var _this = this;
                vm.$f7.dialog.confirm($translate.instant("remove_x_items_permanantly", { "count": vm.selectedItems.length }), "", function () {
                    var list = _this.list;
                    var selectedItems = _this.selectedItems;
                    selectedItems.forEach(function (item) {
                        list.deleteItem(item);
                    });
                    if (_this.selectedItems.length)
                        _this.selectedItems = [];
                    app.save();
                });
            },
            shareItems: function () {
                var _this = this;
                var list = this.list;
                var items = this.selectedItems.length ? this.selectedItems : list.items;
                var promise = thatlist.util.share(list.itemsToText(items), list.title, $translate.instant("share_items"));
                promise.then(function () { if (_this.selectedItems.length)
                    _this.selectedItems = []; });
                return promise;
            },
            copyItems: function () {
                var _this = this;
                var list = this.list;
                var items = this.selectedItems.length ? this.selectedItems : list.items;
                var promise = thatlist.util.clipboard.copy(list.itemsToText(items));
                promise.then(function () { if (_this.selectedItems.length)
                    _this.selectedItems = []; });
                return promise;
            },
            cutItems: function () {
                var list = this.list;
                var selectedItems = this.selectedItems;
                this.copyItems().then(function () {
                    if (!selectedItems.length) {
                        list.clearItems();
                    }
                    else {
                        selectedItems.forEach(function (item) {
                            list.removeItem(item);
                        });
                    }
                });
            },
            pasteItems: function () {
                var _this = this;
                var list = this.list;
                thatlist.util.clipboard.paste().then(function (text) {
                    var items = thatlist.util.parseItemsText(text);
                    _this.addItems(items, { "sort": false, "check": true, "animate": false });
                });
            },
            pickItem: function (item, options) {
                var _this = this;
                var list = this.list;
                //clear selection
                if (this.selectedItems.length)
                    this.selectedItems = [];
                setTimeout(function () {
                    list.removeItem(item);
                    if (list.items.length === 0) {
                        if (_this.shoppingModeOn)
                            _this.shoppingModeOn = false;
                        thatlist.util.allowSleep();
                    }
                    else {
                        if (!_this.shoppingModeOn)
                            _this.shoppingModeOn = true;
                        thatlist.util.keepAwake();
                    }
                    setTimeout(function () {
                        list.addPickedItem(item);
                        app.save();
                    }, 220);
                }, Framework7.device.ios ? 10 : 70);
            },
            addItemsFromPickedItems: function () {
                var list = this.list;
                vm.$f7.dialog.confirm($translate.instant("add_all"), "", function () {
                    list.addItems(list.pickedItems.slice(0, list.pickedItemsLimit), { "clearPicked": true });
                    app.save();
                });
            },
            hidePickedItems: function () {
                var list = this.list;
                vm.$f7.dialog.confirm($translate.instant("remove_all"), "", function () {
                    list.hidePickedItems();
                    app.save();
                });
            },
            // setItemCollection: function (items, actionNames: string[]) {
            //   if (!items || !items.length) return;
            //   this.itemsCollection = items;
            //   let actions = {
            //     "add": {
            //       "title": $translate.instant("add"),
            //       "icon-ios": "",
            //       "icon-md": "",
            //       "action": (item) => {
            //       }
            //     }
            //   };
            //   actionNames.forEach(actionName => {
            //     this.itemsCollectionActions.push(actions[actionName]);
            //   });
            // },
            startRecordSpeech: function (continueRecording) {
                var _this = this;
                window.cancelRecordSpeech = false;
                window.speechText = "";
                var list = this.list;
                this.speechActive = true;
                if (!continueRecording) {
                    window.previewItemsToAddOffset = 0;
                    this.previewItemsToAdd = [];
                }
                thatlist.util.recordSpeech(app.getLanguage(), function (text) {
                    if (window.cancelRecordSpeech) {
                        log("cancelRecordSpeech");
                        return;
                    }
                    // window.recentVoiceInput = Date.now();
                    log(window.speechText, text);
                    if (!_this.speechActive || window.speechText === text) {
                        //   //android terminate record
                        //   this.stopRecordSpeech();
                        return;
                    }
                    window.speechText = text;
                    var itemsCollection = list.parseItemsFromSpeech(text);
                    // let inputChanged = false;
                    itemsCollection.forEach(function (item, i) {
                        i = i + window.previewItemsToAddOffset;
                        var curPrevItem = _this.previewItemsToAdd[i];
                        if (!curPrevItem || curPrevItem.name !== item.name) {
                            _this.list.checkCategory(item);
                            _this.previewItemsToAdd.splice(i, 1, item);
                            // inputChanged = true
                        }
                    });
                    // if (!inputChanged) {
                    //   this.stopRecordSpeech();
                    //   return;
                    // }
                    Vue.nextTick(function () {
                        var el = document.getElementById("preview-dialog-content");
                        if (el)
                            el.scrollTo(0, el.offsetHeight);
                    });
                }, function (err) {
                    log("recordSpeech failed", err);
                    // window.speachToast.close();
                    _this.speechActive = false;
                });
            },
            continueRecordSpeech: function () {
                window.previewItemsToAddOffset = this.previewItemsToAdd.length;
                this.startRecordSpeech(true);
            },
            addItemsFromPreview: function () {
                this.addItems(this.previewItemsToAdd, { "sort": false, "check": true, "animate": false });
                this.recentAddItem = this.previewItemsToAdd[0];
                this.previewItemsToAdd = [];
                this.stopRecordSpeech();
                this.list.sort();
                if (!this.fixDuplicateAction)
                    this.cancelInput();
                // this.setItemCollection(itemsCollection, ["add"]);
                // alert(JSON.stringify(itemsCollection));
                // window.speachToast.close();
                // this.speechActive = false;
            },
            stopRecordSpeech: function () {
                if (this.speechActive) {
                    log("stopRecordSpeech");
                    this.speechActive = false;
                    // this.focusInput();
                    thatlist.util.stopRecordSpeech();
                }
            },
            addItemsFromFavourites: function () {
                var _this = this;
                var list = this.list;
                vm.$f7.dialog.confirm($translate.instant("add_all"), "", function () {
                    list.addItems(list.favourites);
                    app.save();
                    //close modal
                    _this.clearGUI();
                    handleBack();
                });
            },
            addList: function (edit) {
                var newList = app.addList();
                if (edit) {
                    this.setEditList(newList, true);
                }
                else {
                    this.selectList(newList.ts);
                }
            },
            cloneList: function () {
                var _this = this;
                vm.$f7.dialog.prompt(translation.list_name_enter, translation.clone_list, function (title) {
                    var newList = app.cloneList(_this.list);
                    if (title)
                        newList.title = title || (_this.list.title + " 2");
                    _this.selectList(newList.ts);
                });
                var ipt = $$(".dialog-input")[0];
                ipt.value = this.list.title + " 2";
                ipt.focus();
                ipt.setSelectionRange(0, 1000);
                thatlist.util.showKeyboard();
            },
            setEditList: function (list, isNew) {
                var _this = this;
                if (list)
                    this.selectList(list.ts);
                this.editList = JSON.parse(thatlist.util.toJSON(this.list));
                if (isNew)
                    this.editList.tmp = { "new": true };
                this.editListOrig = this.list;
                Vue.nextTick(function () {
                    vm.$f7.views.main.router.navigate("/lists/" + _this.list.ts + "/edit");
                });
            },
            saveEditList: function () {
                var checkProps = {
                    "title": "list_name_enter"
                };
                for (var propName in checkProps) {
                    if (!this.editList[propName]) {
                        vm.$f7.toast.create({
                            text: $translate.instant(checkProps[propName]),
                            closeTimeout: 4000,
                            destroyOnClose: true
                        }).open();
                        return;
                    }
                }
                this.editListOrig.title = this.editList.title;
                app.save();
                this.clearGUI();
                vm.$f7.views.main.router.navigate("/lists/" + app.selectedListTS, { "reloadAll": true });
                vm.$f7.panel.enableSwipe("left");
            },
            onSortLists: function (e) {
                // Sort data
                var movedList = this.app.lists.splice(e.detail.from, 1)[0];
                this.app.lists.splice(e.detail.to, 0, movedList);
                //this.app.lists.splice(e.detail.to + (e.detail.from < e.detail.to ? 0 : 1), 0, movedList);
                app.save();
            },
            removeList: function (list) {
                var _this = this;
                if (!list)
                    list = this.list;
                vm.$f7.dialog.confirm($translate.instant("list_delete", { "title": list.title }), '', function () {
                    app.deleteList(list);
                    if (!app.lists.length) {
                        _this.addList(true);
                    }
                    else {
                        _this.selectList(app.lists[0].ts);
                    }
                });
            },
            clearList: function () {
                var list = this.list;
                vm.$f7.dialog.confirm($translate.instant("clear_list_text"), $translate.instant("clear_list"), function () {
                    list.clearItems();
                    // list.hidePickedItems();
                    app.save();
                });
            },
            connectList: function () {
                var _this = this;
                var list = this.list;
                vm.$f7.preloader.show();
                list.connect().then(function () {
                    vm.$f7.preloader.hide();
                    app.save();
                    var rts = list.ts;
                    //vm.$f7.views.main.router.navigate("/lists/forcerepaint", { "animate": false, "reloadAll": true });
                    vm.$f7.views.main.router.navigate("/lists/" + rts, { "animate": false, "reloadAll": true });
                    _this.syncList();
                    list.invite();
                }, function (err) {
                    vm.$f7.preloader.hide();
                    vm.toast = "connectFailed";
                    setTimeout(function () { _this.toast = ""; }, 10000);
                });
            },
            disconnectList: function () {
                var list = this.list;
                list.disconnect();
                app.save();
                var rts = list.ts;
                //vm.$f7.views.main.router.navigate("/lists/forcerepaint", { "animate": false, "reloadAll": true });
                vm.$f7.views.main.router.navigate("/lists/" + rts, { "animate": false, "reloadAll": true });
            },
            joinList: function (list) {
                if (!list) {
                    list = app.addList();
                    list.title = "";
                }
                list.title = list.title || this.newListTitle || $translate.instant("supermarket");
                list.id = this.joinListId;
                list.token = this.joinListToken;
                app.save();
                console.log("join " + thatlist.util.toJSON(list));
                this.selectList(list.ts, false, true);
            },
            handlePtrRefresh: function (event, done) {
                var _this = this;
                var list = this.list;
                this.toast = "";
                var started = Date.now();
                list.sync().then(function () { setTimeout(function () { done(); }, Math.max(0, (vm.screenshot ? 3000 : 1000) - (Date.now() - started))); }, function () { done(); _this.toast = "syncFailed"; });
            },
            checkBgMode: function () {
                if (Framework7.device.ios && cordova.plugins && cordova.plugins.backgroundMode) {
                    //prepare bg mode
                    if (this.list.token) {
                        if (stopBackgroundTMO)
                            clearTimeout(stopBackgroundTMO);
                        cordova.plugins.backgroundMode.setDefaults({
                            text: $translate.instant("sync")
                        });
                        cordova.plugins.backgroundMode.enable();
                    }
                    else {
                        stopBgMode();
                    }
                }
            },
            syncList: function (tmo) {
                var _this = this;
                this.recentAddItem = null;
                this.rateApp();
                setTimeout(function () {
                    promiseAppReady.then(function () {
                        var list = _this.list;
                        try {
                            if (list.token)
                                vm.$f7.ptr.get('.page-current .ptr-content').refresh();
                        }
                        catch (e) { }
                    });
                }, tmo || 0);
                this.checkBgMode();
            },
            rateApp: function (force) {
                var _this = this;
                if (!force && (this.shoppingModeOn || app.runningtime < 20 * 60)) {
                    return;
                }
                app.runningtime = -60 * 60;
                app.save();
                var buttons = [
                    {
                        "text": $translate.instant("cancel"),
                        "bold": true,
                        "onClick": function () { }
                    },
                    {
                        "text": $translate.instant("like"),
                        "bold": true,
                        "onClick": function () {
                            if (_this.mobileServiceProvider === "apple") {
                                cordova.plugins.market.open("id1082845559");
                            }
                            else if (_this.mobileServiceProvider === "huawei") {
                                // window.open("https://appgallery.cloud.huawei.com/ag/n/app/C101365969?locale=de_DE&source=appshare&subsource=C101365969","_blank")
                                window.open("https://appgallery.cloud.huawei.com/marketshare/app/C101365969", "_blank");
                            }
                            else {
                                cordova.plugins.market.open("de.markusliebschner.thatlist");
                            }
                        }
                    },
                    {
                        "text": $translate.instant("can_be_better"),
                        "bold": true,
                        "onClick": function () {
                            app.runningtime = -200 * 60;
                            app.save();
                            vm.$f7.views.main.router.navigate('/app/feedback');
                        }
                    }
                ];
                var dialog = vm.$f7.dialog.create({
                    title: $translate.instant("rate_title"),
                    text: $translate.instant("rate_text"),
                    verticalButtons: buttons.length > 2,
                    buttons: buttons
                }).open();
            },
            doBackup: function () {
                var _this = this;
                vm.$f7.preloader.show();
                app.doBackup().then(vm.$f7.preloader.hide, function () {
                    if (window.doBackupFailedTMO)
                        clearTimeout(window.doBackupFailedTMO);
                    _this.toast = "doBackupFailed";
                    window.doBackupFailedTMO = setTimeout(function () {
                        if (_this.toast === "doBackupFailed")
                            _this.toast = null;
                    }, 10000);
                    vm.$f7.preloader.hide();
                });
            },
            restoreBackup: function (backupId, noWarn) {
                var _this = this;
                var list = this.list;
                vm.$f7.preloader.show();
                app.loadBackup(backupId, noWarn).then(function (data) {
                    vm.$f7.preloader.hide();
                    if (data.backupDate || data.date) {
                        var msg = "";
                        if (backupId)
                            msg = $translate.instant("load_data_text");
                        else
                            msg = $translate.instant("restore_bck_text", { "date": new Date(data.backupDate || data.date).toLocaleDateString(app.getLanguage()) });
                        if (!noWarn)
                            msg += "\n\n" + $translate.instant("restore_bck_warn");
                        vm.$f7.dialog.confirm(msg, '', function () {
                            app.save(data).then(function () { window.location.replace("/"); window.location.reload(); });
                        });
                    }
                    else {
                        //force reload purchases
                        delete data.purchases;
                        app.save(data).then(function () { window.location.replace("/"); window.location.reload(); });
                    }
                }, function () {
                    vm.$f7.preloader.hide();
                    if (window.restoreBackupFailedTMO)
                        clearTimeout(window.restoreBackupFailedTMO);
                    _this.toast = "restoreBackupFailed";
                    window.restoreBackupFailedTMO = setTimeout(function () {
                        if (_this.toast === "restoreBackupFailed")
                            _this.toast = null;
                    }, 10000);
                });
            },
            transferBackup: function (backupId) {
                var _this = this;
                vm.$f7.preloader.show();
                app.doBackup(true).then(function () {
                    vm.$f7.preloader.hide();
                    thatlist.util.share($translate.instant("data_transfer_msg", { "id": getBackupId() }), $translate.instant("data_transfer_msg_subject"), $translate.instant("backup_share_title"));
                }, function () {
                    if (window.doBackupFailedTMO)
                        clearTimeout(window.doBackupFailedTMO);
                    _this.toast = "doBackupFailed";
                    window.doBackupFailedTMO = setTimeout(function () {
                        if (_this.toast === "doBackupFailed")
                            _this.toast = null;
                    }, 10000);
                    vm.$f7.preloader.hide();
                });
            },
            deleteBackup: function (backupId) {
                vm.$f7.preloader.show();
                app.deleteBackup(backupId).then(vm.$f7.preloader.hide, vm.$f7.preloader.hide);
            },
            changeLanguage: function (lang) {
                app.setLanguage(lang);
                app.save().then(function () {
                    setTimeout(function () { return window.location.reload(); }, 100);
                });
            },
            setSetting: function (key, val) {
                log("setting ", key, val);
                Vue.set(app.settings, key, val);
                if (key === "force_portait")
                    thatlist.util.setOrientation(val === true ? 'portrait' : void (0));
                app.save();
            },
            shake: function (elemSelector) {
                var $elem = $$(elemSelector);
                if (!$elem)
                    return;
                $elem.removeClass('shake');
                setTimeout(function () {
                    $elem.addClass('shake');
                }, 10);
            },
            toggleThemeDark: function () {
                var settings = this.app.settings;
                settings.theme_name = settings.theme_name === "dark" ? "white" : "dark";
                setTheme(settings.theme_primaryColor, settings.theme_accentColor, settings.theme_name === "dark");
                app.save();
            },
            setThemePrimaryColor: function (idx) {
                var settings = this.app.settings;
                settings.theme_primaryColor = settings.theme_primaryColor === idx ? null : idx;
                setTheme(settings.theme_primaryColor, settings.theme_accentColor, settings.theme_name === "dark");
                app.save();
            },
            setThemeAccentColor: function (idx) {
                var settings = this.app.settings;
                settings.theme_accentColor = settings.theme_accentColor === idx ? null : idx;
                setTheme(settings.theme_primaryColor, settings.theme_accentColor, settings.theme_name === "dark");
                app.save();
            },
            sendFeedback: function () {
                var feedback = this.feedback;
                if (!this.feedbackCount)
                    this.feedbackCount = 0;
                this.feedbackCount++;
                if (!feedback || this.feedbackCount > 4 || feedback.length < 3) {
                    handleBack();
                    return;
                }
                //thatlist.util.request(basePath + "/api/list/feedback", "POST",  { "device": window.device.model + " " + window.device.platform + " " + window.device.version, "msg": appversion + ": " + fb });
                window.plugins.socialsharing.shareViaEmail(feedback, $translate.instant("feedback_subject") + " (" + this.mobileServiceProvider.charAt(0) + window.appversion + ")", ['info@markenapps.com'], null, null, null, null);
                handleBack();
            },
            handleURL: function (url) {
                var _this = this;
                var urlParts = url.split("#");
                var hash = urlParts.pop();
                var hashParts = hash.split("!");
                promiseAppReady.then(function () {
                    _this.clearGUI();
                    log("urlParts: " + JSON.stringify(urlParts));
                    if (urlParts[0] === "thatshoppinglist://transfer") {
                        //TODO let oldBackupDate = app.backupDate;
                        _this.restoreBackup(hashParts[0]);
                        //TODO then -> app.backupDate = oldBackupDate; app.save();
                        return;
                    }
                    var currentHash = url.split("#").pop();
                    var idToken = currentHash.split("!");
                    _this.joinListId = idToken[0];
                    _this.joinListToken = idToken[1];
                    if (idToken[2]) {
                        try {
                            _this.newListTitle = decodeURIComponent(escape(window.atob(idToken[2])));
                        }
                        catch (e) {
                            try {
                                _this.newListTitle = window.atob(idToken[2]);
                            }
                            catch (e) {
                                _this.newListTitle = "";
                            }
                        }
                    }
                    else {
                        _this.newListTitle = "";
                    }
                    var alreadyConnected = false;
                    for (var l = 0; l < app.lists.length; l++) {
                        var curList = app.lists[l];
                        //avoid dublicates
                        if (curList.title === _this.newListTitle)
                            _this.newListTitle = "";
                        if (curList.token && curList.id == idToken[0] && curList.token == idToken[1]) {
                            alreadyConnected = true;
                            log("show list_already_conn");
                            _this.$f7.dialog.alert($translate.instant("list_already_conn"), $translate.instant("list_already_conn_title"));
                            // if (this.$f7.views.current.router.history.length) this.$f7.views.current.router.clearHistory();
                            _this.$f7.views.main.router.navigate("/lists/" + curList.ts);
                        }
                    }
                    if (!alreadyConnected) {
                        // if (this.$f7.views.current.router.history.length) this.$f7.views.current.router.clearHistory();
                        _this.$f7.views.main.router.navigate("/app/join");
                    }
                });
            },
            restorePurchases: function () {
                app.onOwnedPurchase(function (purchases) {
                    //hide ads only when purchses where loaded (otherwise in case of a offline device ads will never be visible)
                    if (app.purchases && app.purchases.length) {
                        thatlist.util.showAd(false);
                    }
                });
            },
            removeAds: function () {
                // vm.$f7.preloader.show();
                app.buyProduct(Framework7.device.ios ? noads2ProductId : noadsProductId).then(function (purchase) {
                    // vm.$f7.preloader.hide();
                    thatlist.util.showAd(false);
                }, function () {
                    // vm.$f7.preloader.hide();
                    thatlist.util.showAd(true);
                });
            },
            debounce: function (propName, propValue, delay) {
                var _this = this;
                if (!window.debounceTMOS)
                    window.debounceTMOS = {};
                if (window.debounceTMOS[propName])
                    clearTimeout(window.debounceTMOS[propName]);
                window.debounceTMOS[propName] = setTimeout(function () {
                    _this[propName] = propValue;
                    delete window.debounceTMOS[propName];
                }, delay);
            },
            // blurElem: function (event) {
            //   console.log(event);
            //   event.target.blur();
            // },
            scrolledToBottom: function (event) {
                var el = event.srcElement;
                if (!this.historyReachedBottom) {
                    if (el.scrollTop + el.offsetHeight + 100 >= el.scrollHeight * (1 / 2)) {
                        this.historyReachedBottom = true;
                        if (this.curHistoryTab === "prio") {
                            this.debounce("historyPrioLimit", this.historyPrioLimit + 50, 50);
                        }
                        else {
                            this.debounce("historyCatLimit", this.historyCatLimit + 50, 50);
                        }
                    }
                }
                else {
                    this.historyReachedBottom = false;
                }
            },
            handleHistoryTapShow: function (tabName) {
                var _this = this;
                console.log("handleHistoryTapShow", tabName);
                this.curHistoryTab = tabName;
                if (this.curHistoryTab === "prio") {
                    setTimeout(function () {
                        thatlist.util.scrollCurrentPageTo(0);
                        _this.historyPrioLimit = 50;
                    }, 0);
                    this.favouritesByPrio = this.list.getFavourites("prio");
                }
                else {
                    setTimeout(function () {
                        thatlist.util.scrollCurrentPageTo(0);
                        _this.historyCatLimit = 50;
                    }, 0);
                    this.favouritesByCategory = this.list.getFavourites("cat");
                }
            },
            // execCmd: function (cmd) {
            //   var r = eval(cmd);
            //   if (r) {
            //     if (typeof r === "object") alert(JSON.stringify(r));
            //     else alert(r);
            //   }
            // },
            sendLog: function () {
                var appData = thatlist.util.toJSON(app);
                window.logError(appData.substring(0, 13000));
                vm.$f7.toast.create({
                    text: $translate.instant("send_log_done"),
                    closeTimeout: 2000,
                    destroyOnClose: true
                }).open();
            }
        },
        watch: {
            locked: function (newVal, oldVal) {
                var isLocked = !!newVal;
                var lockMenu = isLocked;
                if (isLocked)
                    vm.$f7.panel.disableSwipe("left");
                else
                    vm.$f7.panel.enableSwipe("left");
                //vm.$f7.panel.allowOpen = !isLocked;
                if (isLocked) {
                    if (!app.settings.force_portait)
                        thatlist.util.setOrientation('portrait');
                    if (!Framework7.device.ios)
                        thatlist.util.setStatusbarHidden(true);
                    thatlist.util.keepAwake();
                }
                else {
                    if (!app.settings.force_portait)
                        thatlist.util.setOrientation();
                    if (!Framework7.device.ios)
                        thatlist.util.setStatusbarHidden(false);
                    thatlist.util.allowSleep();
                }
            }
        },
        computed: {
            expectedCharSize: function () {
                var fontSize = this.app.settings.fontSize || 3;
                return 9 + fontSize;
            },
            expectedAmountWordSize: function () {
                return $translate.instant("amount").length * this.expectedCharSize;
            },
            filteredFavouritesByPrio: function () {
                var list = this.list;
                if (this.historyPrioLimit >= this.favouritesByPrio.length)
                    return this.favouritesByPrio;
                console.log("filteredFavouritesByCategory " + this.historyPrioLimit);
                return this.favouritesByPrio.slice(0, this.historyPrioLimit);
            },
            filteredFavouritesByCategory: function () {
                var list = this.list;
                if (this.historyCatLimit >= this.favouritesByCategory.length)
                    return this.favouritesByCategory;
                console.log("filteredFavouritesByCategory " + this.historyCatLimit);
                return this.favouritesByCategory.slice(0, this.historyCatLimit);
            },
            parsedItem: function () {
                var _this = this;
                if (!this.filterText) {
                    return [];
                }
                var list = this.list;
                var item = thatlist.util.parseItemName(this.filterText.trim());
                //list.checkCategory(item);          
                var oldCat = this.parsedItemCat.cat;
                this.parsedItemCat = JSON.parse(JSON.stringify(item));
                this.parsedItemCat.tmp = { "count": this.parsedItemCat.count };
                if (item.name.length > 2 || app.getLanguage() === "ja") {
                    if (oldCat)
                        Vue.set(this.parsedItemCat, "cat", oldCat);
                    if (window.detectCatTMO)
                        clearTimeout(window.detectCatTMO);
                    window.detectCatTMO = setTimeout(function () {
                        list.checkCategory(item);
                        Vue.set(_this.parsedItemCat, "cat", item.cat);
                    }, 200);
                }
                return item;
            },
            filteredUnits: function () {
                if (!this.app)
                    return [];
                if (this.parsedItem.name)
                    return [];
                var app = this.app;
                log("calc getFilteredUnits");
                return app.getFilteredUnits(this.parsedItem);
            },
            filteredItems: function () {
                if (!this.app)
                    return [];
                var list = this.list;
                log("calc geFilteredItems");
                if (this.filterText) {
                    window.oldScrollPos = thatlist.util.scrollCurrentPageTo(0);
                }
                else {
                    Vue.nextTick(function () { thatlist.util.scrollCurrentPageTo(window.oldScrollPos); });
                }
                var items = list.getCatalogItems(this.parsedItem);
                var itemIdx = thatlist.util.indexOfItem(this.parsedItem.name, items);
                if (this.parsedItem.name && itemIdx >= 0) {
                    items.splice(itemIdx, 1);
                }
                return items;
            },
            categories: function () {
                var list = this.list;
                if (!list)
                    return [];
                var catOrder = list.catOrder;
                var cats = this.app.categories;
                var categories = [];
                catOrder.forEach(function (catName) {
                    categories.push(cats[catName]);
                });
                return categories;
            },
            hiddenCategories: function () {
                var list = this.list;
                var catOrder = list.catOrder;
                var cats = this.app.categories;
                var hiddenCats = Object.values(cats).filter(function (cat) { return catOrder.indexOf(cat.name) < 0; });
                return hiddenCats;
            },
            categoryColorVariations: function () {
                var _this = this;
                if (!this.editCategory || !this.editCategory.colorName)
                    return [];
                var color = this.colors.find(function (color) { return color.color === _this.editCategory.colorName; });
                return color.variations || [];
            },
            selectedPrimaryColor: function () {
                var dark = this.app.settings.theme_name === "dark";
                return {
                    "hex": window.defaultPrimaryColor(this.app.settings.theme_primaryColor, 0, dark) || "#7f58c2",
                    "index": this.app.settings.theme_primaryColor
                };
            },
            selectedAccentColor: function () {
                var dark = this.app.settings.theme_name === "dark";
                return {
                    "hex": window.accentPrimaryColor(0, this.app.settings.theme_accentColor, dark) || "#f36597",
                    "index": this.app.settings.theme_accentColor
                };
            },
            primaryColors: function () {
                var dark = this.app.settings.theme_name === "dark";
                var colors = [];
                window.theme_colors.forEach(function (colorDef, index) {
                    if (["yellow"].indexOf(colorDef.key) >= 0)
                        return;
                    var color = window.defaultPrimaryColor(index, 0, dark);
                    if (color) {
                        colors.push({
                            "hex": color,
                            "index": index
                        });
                    }
                });
                return colors;
            },
            accentColors: function () {
                var dark = this.app.settings.theme_name === "dark";
                var colors = [];
                window.theme_colors.forEach(function (colorDef, index) {
                    if (["yellow"].indexOf(colorDef.key) >= 0)
                        return;
                    var color = window.accentPrimaryColor(0, index, dark);
                    if (color) {
                        colors.push({
                            "hex": color,
                            "index": index
                        });
                    }
                });
                return colors;
            },
            needBackup: function () {
                return !this.app.backupDate || (Date.now() - new Date(this.app.backupDate).getTime() > 1000 * 60 * 60 * 12);
            }
        }
    });
}
var dataPromise = new Promise(function (resolve, reject) {
    thatlist.util.readFile("shoppinglist.json", true).then(function (localdata) {
        log("localdata ", localdata.substring(0, 100));
        if (!localdata) {
            resolve({});
            log("no local data yet");
        }
        try {
            resolve(JSON.parse(localdata));
        }
        catch (e) {
            var parts = localdata.split("}{");
            if (parts.length > 1) {
                localdata = "{" + parts.pop();
                try {
                    resolve(JSON.parse(localdata));
                }
                catch (e) {
                    log("parse local data failed " + e.message);
                    log(localdata);
                    //TODO retry
                }
            }
        }
    }, function (e) {
        //TODO retry
        logError("read local data failed " + e.message);
    });
});
var preparedPromise = new Promise(function (resolve) {
    //try local xhr before deviceready will fail on ios because cordova-plugin-wkwebview-file-xhr plugin is required
    thatlist.util.requestJSON("res/assets/colors.json").then(function () { resolve(); }, function () { return thatlist.util.promiseDeviceReady().then(function () { resolve(); }); });
});
preparedPromise.then(function () {
    dataPromise.then(function (localdata) {
        log(localdata);
        var lang = localdata && localdata.settings && localdata.settings.lang;
        if (!lang) {
            try {
                lang = Framework7.utils.parseUrlQuery().lang;
            }
            catch (e) {
                console.log("error getting lang from query string");
            }
        }
        if (!lang) {
            lang = thatlist.util.getFirstBrowserLanguage();
        }
        var promises = [];
        var goodsPromise = new Promise(function (resolve) {
            thatlist.util.requestJSON("res/assets/goods_" + lang + ".json").then(function (data) {
                resolve(data);
            }, function () {
                resolve([]);
            });
        });
        promises.push(goodsPromise);
        if (!thatlist.App.getSupportedLanguages()[lang])
            lang = "en";
        var categoriesPromise = thatlist.util.requestJSON("res/assets/caths_" + lang + ".json").then(null, function () { return thatlist.util.requestJSON("res/assets/caths.json"); });
        promises.push(categoriesPromise);
        var unitsPromise = thatlist.util.requestJSON("res/assets/units_" + lang + ".json");
        promises.push(unitsPromise);
        var colorsPromise = thatlist.util.requestJSON("res/assets/colors.json");
        promises.push(colorsPromise);
        var transPromise = thatlist.util.requestJSON("res/translations/" + lang + ".json");
        promises.push(transPromise);
        Promise.all(promises).then(function (assets) {
            translation = assets[4];
            document.title = translation.app_title;
            var cats = assets[1];
            var wordsToNumber = cats.wordsToNumber;
            delete cats.wordsToNumber;
            var numberJoinWordRegExp = cats.numberJoinWordRegExp ? new RegExp(cats.numberJoinWordRegExp, "g") : void (0);
            delete cats.numberJoinWordRegExp;
            app = new thatlist.App(localdata, { "goods": assets[0], "categories": cats, "units": assets[2] });
            // app.settings.lang = lang;
            initVue(assets);
            vm.wordsToNumber = wordsToNumber;
            vm.numberJoinWordRegExp = numberJoinWordRegExp;
            Vue.nextTick(function () {
                setTimeout(function () {
                    var pl = document.getElementById("preloader");
                    if (pl)
                        document.getElementById("preloader").style.display = "none";
                    clearTimeout(window.appNotStartingTMO);
                    var toastElem = document.getElementById("toasts");
                    if (toastElem)
                        document.getElementById("toasts").style.display = "block";
                }, 50);
                //update purchases randomly  || Math.random() < 0.02
                if (!app.purchases) {
                    setTimeout(function () {
                        vm.restorePurchases();
                    }, 1000);
                }
                if (app.hasAds()) {
                    thatlist.util.showAd(true);
                }
            });
        }, function (errors) {
            log(errors);
            logError("load assets failed");
        });
        thatlist.util.promiseDeviceReady().then(function () {
            if (navigator.splashscreen)
                navigator.splashscreen.hide();
            document.addEventListener("backbutton", function (event) {
                return handleBack(event);
            }, false);
            document.addEventListener("pause", function () {
                promiseAppReady.then(function () {
                    var list = vm.list;
                    if (app.tmp.lastResume) {
                        app.runningtime += Math.min(60 * 5, Math.round((Date.now() - app.tmp.lastResume) / 1000));
                        app.tmp.lastResume = null;
                    }
                    app.save();
                    //ios uses bg sync
                    if (cordova.plugins || !cordova.plugins.backgroundMode || !cordova.plugins.backgroundMode.isEnabled()) {
                        //TODO notification
                        list.commit(true);
                    }
                    thatlist.util.allowSleep();
                });
            }, false);
            document.addEventListener("resume", function () {
                promiseAppReady.then(function () {
                    log("resume");
                    vm.locked = false;
                    vm.shoppingModeOn = false;
                    vm.syncList();
                    vm.clearGUI();
                    //thatlist.util.scrollCurrentPageTo(0);
                    app.tmp.lastResume = Date.now();
                    thatlist.util.allowSleep();
                });
            }, false);
            thatlist.util.promiseMobileServiceProviderCheckDone().then(function (provider) {
                promiseAppReady.then(function () {
                    vm.mobileServiceProvider = provider;
                });
            });
            if (Framework7.device.ios && cordova.plugins && cordova.plugins.backgroundMode) {
                cordova.plugins.backgroundMode.on('enable', function () {
                    log("bg enable");
                });
                cordova.plugins.backgroundMode.on('disable', function () {
                    log("bg disable");
                });
                cordova.plugins.backgroundMode.on('deactivate', function () {
                    log("bg deactivate");
                });
                cordova.plugins.backgroundMode.on('failure', function () {
                    log("bg failure");
                });
                cordova.plugins.backgroundMode.on('activate', function () {
                    log("bg activate");
                    //limit in time
                    stopBgMode(vm && vm.list.needsSync() ? 80000 : 0);
                    if (vm) {
                        var list = vm.list;
                        if (list.needsSync()) {
                            log("bg sync");
                            list.commit(true).then(function () {
                                log("bg sync success");
                                stopBgMode();
                            }, function () {
                                log("bg sync failed");
                                //TODO retry ... notification
                                stopBgMode();
                            });
                        }
                        else {
                            stopBgMode();
                        }
                    }
                });
            }
            if (Framework7.device.ios) {
                window.addEventListener('keyboardDidShow', function (event) {
                    keyboardHeight = vm.curKeyboardHeight = event.keyboardHeight;
                    var bannerOffset = window.screen.availHeight - window.innerHeight;
                    var navbarHeight = 120;
                    //scroll into view for count input
                    if (document.activeElement && $$(document.activeElement).hasClass("quick-input")) {
                        window.setTimeout(function () {
                            var scrollElem = $$(vm.$f7.views.main.router.currentPageEl).find(".page-current .page-content")[0];
                            scrollElem.scrollTop -= window.innerHeight - vm.curKeyboardHeight + bannerOffset - navbarHeight - document.activeElement.getBoundingClientRect().y;
                        }, 0);
                    }
                    Vue.nextTick(function () {
                        $$(".fab").css("bottom", (15 + vm.curKeyboardHeight - bannerOffset) + "px");
                    });
                });
                window.addEventListener('keyboardWillHide', function () {
                    if (vm) {
                        vm.curKeyboardHeight = 0;
                        // if (vm.app.hasAds()) {
                        //   if (throttleToggleBannerTMO) clearTimeout(throttleToggleBannerTMO);
                        //   throttleToggleBannerTMO = setTimeout(() => {
                        //     thatlist.util.showAd(true);
                        //   }, 500);
                        // }
                        $$(".fab").css("bottom", 15 + "px");
                    }
                });
                window.addEventListener('keyboardWillShow', function (event) {
                    var bannerOffset = window.screen.availHeight - window.innerHeight;
                    $$(".fab").css("bottom", (15 + keyboardHeight - bannerOffset) + "px");
                    // if (vm.app.hasAds()) {
                    //   if (throttleToggleBannerTMO) clearTimeout(throttleToggleBannerTMO);
                    //   throttleToggleBannerTMO = setTimeout(() => {
                    //     thatlist.util.showAd(false);
                    //   }, 10)
                    // }
                });
                window.addEventListener("orientationchange", function () {
                    if (vm.app.hasAds()) {
                        if (throttleToggleBannerTMO)
                            clearTimeout(throttleToggleBannerTMO);
                        thatlist.util.showAd(false);
                        throttleToggleBannerTMO = setTimeout(function () {
                            thatlist.util.showAd(true);
                        }, 1000);
                    }
                });
            }
            else {
                window.addEventListener('keyboardDidShow', function (event) {
                    keyboardHeight = vm.curKeyboardHeight = event.keyboardHeight;
                    var bottomOffset = 120;
                    //scroll into view for count input
                    if (document.activeElement && $$(document.activeElement).hasClass("quick-input")) {
                        window.setTimeout(function () {
                            var scrollElem = $$(vm.$f7.views.main.router.currentPageEl).find(".page-current .page-content")[0];
                            document.activeElement.scrollIntoView();
                            scrollElem.scrollBy(0, -window.innerHeight + bottomOffset);
                        }, 0);
                    }
                });
                window.addEventListener('keyboardWillHide', function () {
                    if (vm) {
                        vm.curKeyboardHeight = 0;
                    }
                });
            }
            // window.addEventListener("resize", () => {
            //   window.setTimeout(function () {
            //     let scrollElem = $$(vm.$f7.views.main.router.currentPageEl).find(".page-current .page-content")[0];
            //     scrollElem.scrollTop -= window.innerHeight - 120 - document.activeElement.getBoundingClientRect().y
            //   }, 0);
            // })
            // window.addEventListener('keyboardDidShow', function (event) {
            //   log("show");
            //   // document.activeElement.scrollIntoView({ behavior: 'smooth', block: 'center' });
            // });
        });
    }, function () {
        //TODO handle
        alert("loading data failed");
    });
});
function handleBack(event) {
    log("handle back");
    if (window.playerObj)
        window.closePlayer();
    if (!vm)
        return;
    if (vm.locked) {
        if (vm)
            vm.shake('#lock-button');
        return;
    }
    if (vm.selectListAction) {
        vm.selectListAction = null;
        return false;
    }
    if (vm.fixDuplicateAction) {
        vm.fixDuplicateAction = null;
        return false;
    }
    if (vm.selectedItems && vm.selectedItems.length) {
        vm.selectedItems = [];
    }
    if (vm.recentAddItem)
        vm.recentAddItem = null;
    if (vm.toast)
        vm.toast = null;
    if (vm.focusedItem)
        vm.focusedItem = null;
    if (vm.focusedCategory)
        vm.focusedCategory = null;
    if (vm.showHiddenCats)
        vm.showHiddenCats = null;
    if (recentExitBack) {
        if (Date.now() - recentExitBack < 600) {
            setTimeout(function () { thatlist.util.exit(); }, vm.list && vm.list.needsSync() ? 300 : 0);
            return;
        }
        else if (Date.now() - recentExitBack < 2000) {
            recentExitBack = Date.now();
            return;
        }
    }
    var leftp = vm.$f7.panel.left && vm.$f7.panel.left.opened;
    var rightp = vm.$f7.panel.right && vm.$f7.panel.right.opened;
    if (leftp || rightp) {
        log("close panels");
        vm.$f7.panel.close();
        return false;
    }
    else if ($$('.modal-in').length > 0) {
        log("close modals");
        vm.$f7.toast.close();
        vm.$f7.dialog.close();
        vm.$f7.popover.close();
        vm.$f7.actions.close();
        return false;
    }
    else if (vm.filterText) {
        log("clear filterText");
        vm.cancelInput();
        return false;
    }
    else if (vm.$f7.views.current.router.url == '/lists/' + app.selectedListTS) {
        recentExitBack = Date.now();
        app.save();
        if (event && !app.settings.tips_hide && !Framework7.device.ios) {
            vm.$f7.toast.create({
                text: $translate.instant("teaser_close_text"),
                closeTimeout: 1500,
                destroyOnClose: true
            }).open();
        }
        return false;
    }
    else {
        log("router back");
        // let hist = vm.$f7.views.current.history;
        // let prevURL = hist[hist.length - 2];
        vm.$f7.views.current.router.back();
        //vm.$f7.views.main.router.back()
    }
}
var promiseAppReady = new Promise(function (resolve) {
    var appReadyPromiseINT = setInterval(function () {
        if (!vm || !vm.app)
            return;
        log("app ready");
        clearInterval(appReadyPromiseINT);
        resolve();
    }, 100);
});
promiseAppReady.then(function () {
    vm.$f7.statusbar.setBackgroundColor(window.statusBarColor);
    vm.$f7.on("routeChanged", function (to, from, router) {
        log("changed " + from.url + " > " + to.url);
        if (from.url && to.url) {
            var toParts = to.url.substring(1).split("/");
            var fromParts = from.url.substring(1).split("/");
            //vm.$f7.panel.allowOpen = toParts[0] === "lists" && toParts[1] && !toParts[2];
            var listChanged = fromParts[0] === "lists" && toParts[0] === "lists" && fromParts[1] !== toParts[1];
            var appRouteChange = (fromParts[0] === "app") && to.url !== from.url;
            if (toParts[0] === "lists" && toParts[1] && !toParts[2]) {
                // console.log("enableSwipe");
                vm.$f7.panel.enableSwipe("left");
            }
            else {
                // console.log("disableSwipe");
                vm.$f7.panel.disableSwipe("left");
            }
            if (listChanged || appRouteChange) {
                // log("clear history " + router.history.length);
                // if (router.history.length) router.clearPreviousHistory();
            }
        }
    });
});
function stopBgMode(tmo) {
    if (stopBackgroundTMO)
        clearInterval(stopBackgroundTMO);
    stopBackgroundTMO = setTimeout(function () {
        cordova.plugins.backgroundMode.disable();
        stopBackgroundTMO = setInterval(function () {
            cordova.plugins.backgroundMode.disable();
        }, 750);
    }, tmo || 0);
}
