var fs = require('fs');
var path = require('path');
var request = require('request');

/*
* https://tech.yandex.com/translate/doc/dg/concepts/api-overview-docpage/
* api key trnsl.1.1.20160331T072845Z.ef8c38fcc2554fea.be73b728119632e0e78bb5a0c20b41115ddcfcea
*/


var lang = "cs";
var goods = [["Cu", "Tortenguss", 3], ["D", "Orangensaft", 3]]//fs.readFileSync("www/res/assets/goods_de.json", "utf8")

var transGoods = [];
var goodsDone = {};
function autotrans() {
    for (var g = 0; g < goods.length; g++) {
        (function (curGood) {
            var options = {
                uri: 'http://dev.tickets.cloudstack5.appspot.com/!A8Zaqgka9tKK973QSgPvRnAVcvcWso4soR1kp0/api/trans/',
                method: 'POST',
                json: { "texts": curGood[1], "from": "de", "to": lang }
            };

            request(options, function (error, response, data) {
                console.log(data);
                if (goodsDone[data.text[0]]) return;

                if (curGood[1] === data.text[0]) {
                    console.log(data.text[0]);
                    return;
                }

                goodsDone[data.text[0]] = true;
                transGoods.push([curGood[0], data.text[0], curGood[2] || 0]);
            })
        })(goods[g])

    }
}

function dedub() {
    goods.sort(function (a, b) { if (a < b) return -1; if (b < a) return 1; return 0 })
    for (var i = goods.length - 1; i--;) {
        if (goods[i][1] == goods[i + 1][1]) {
            console.error("dub " + goods[i][1])
            goods.splice(i, 1);
        }
    }
}

function genTrans() {
    for (var cat in cats) {
        var curCat = cats[cat]
        console.log(curCat.title + ";" + (curCat.keywords.join(";")))
    }

    for (var i = 0; i < goods.length; i++) {
        var curGood = goods[i];
        if (!curGood[2] || curGood[2] < 2) continue;
        console.log(curGood[1] + ";" + curGood[1])
    }


    for (var i = 0; i < units.length; i++) {
        var curUnit = units[i];
        console.log((curUnit.name || "") + ";" + curUnit.title + ";" + curUnit.title_sing)
    }

    for (var key in trans) {
        var curTrans = trans[key];
        console.log(key + ";" + curTrans + ";" + curTrans)
    }
}

autotrans();

/**
 * use google translate
 */

//1: make google translatable goods_de = goods_de.json
goods_de.forEach((g, i) => {
    if (i % 300 === 0) console.log("\n\n");
    console.log(i + ": " + g[1])
})

//2: erg in string array umwandeln ohne zahlen
// var goods = ["κάλυμμα κέικ",
// "χυμός πορτοκαλιού",
// "πορτοκάλια",
// "θαλασσινό αλάτι",
// "μοσχοκάρυδο",
// "Πόδια κοτόπουλου",
// "τραγανό γιαούρτι",...]

//3: add prios and cats
goods_de.forEach((g, i) => {
    goods[i] = [g[0], goods[i], g[2] || 1]
})

//4 erste buchstabe to upper case
goods.forEach((g, i) => {
    g[1] = g[1].charAt(0).toUpperCase() + g[1].substring(1);
})

//5: vergleichen welche namen sich nicht geändert haben und entfernen
for (var i = goods.length; i--;) {
    if (goods[i][1] === goods_de[i][1]) goods.splice(i, 1)
}

//6: dedub
dedub()

//for non ascii alphabet langs (ja,ko) ... filter goods with ascii chars
var alphabet = ["q", "w", "e", "r", "t", "z", "u", "i", "o", "p", "a", "s", "d", "f", "g", "h", "j", "k", "l", "y", "x", "c", "v", "b", "n", "m"]
for (var i = goods.length; i--;) {
    var goodName = goods[i][1];

    for (var c = 0; c < goodName.length; c++) {
        var curChar = goodName[c];

        if (alphabet.indexOf(curChar) >= 0) {
            console.log("remove " + goodName);
            goods.splice(i, 1)
            break;
        }
    }
}